commit:     af8c2c2f04c5648feed000b7d95ba68294195b95
Author:     Maciej Barć <xgqt <AT> gentoo <DOT> org>
AuthorDate: Fri Jun 13 17:55:22 2025 +0000
Commit:     Maciej Barć <xgqt <AT> gentoo <DOT> org>
CommitDate: Fri Jun 13 19:00:40 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=af8c2c2f

dev-lang/nim: bump to 2.2.4

Signed-off-by: Maciej Barć <xgqt <AT> gentoo.org>

 dev-lang/nim/Manifest         |   1 +
 dev-lang/nim/nim-2.2.4.ebuild | 194 ++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 195 insertions(+)

diff --git a/dev-lang/nim/Manifest b/dev-lang/nim/Manifest
index 2449ca6a58e0..7d083955c431 100644
--- a/dev-lang/nim/Manifest
+++ b/dev-lang/nim/Manifest
@@ -1,3 +1,4 @@
 DIST nim-2.2.0.tar.xz 7896912 BLAKE2B 
671b1f5551e093933519797bbfe2875c1726a0cdd1b33288a9ab189fb966fdb21583027345e58ab13d7e7e85479aafc52340e8ddecd062aca4b4b8de6466b88e
 SHA512 
56374815770b1b92bef3521471a3b1a8b810646eb7f978ff329075d64d231a7d1591a928c28407aa507f1b59375d539fc81b678b84f6b8b4a88ed274048ebf21
 DIST nim-2.2.2.tar.xz 8188616 BLAKE2B 
e9b5dc3d12165fe12555a22fbf2125f1dc6e828ae5ce9f146c2347b2629623491498a0cf681355379d0c2252aa7d4d7d02d201a8722838da93b785b1a6dd3af6
 SHA512 
8b61fa55918e01adc782250b5cb931303adeaf185ee65faf3f1fd3843a0050dc7f3dfb363848f8769045e5ac5663f390ae4d8070906cdf0892d749f4426902b3
+DIST nim-2.2.4.tar.xz 8168916 BLAKE2B 
0dfa291e1685772371e26366468e469d098fd9ddab0453c905615757a619ef2c4393c24d4431e9166e2fa02101b26f10d12c29908cd60cc11c79b1cb58eb319b
 SHA512 
02dea77bc4759a9772ff0e7648d98e40c499088d4cb66647a9ecf1df4c4434f80d42188205bd8c8a5b00c0ebe045fd98ac875104fc40ee7b913ba69b0bd13bbe
 DIST nim-atlas-0.8.0.tar.gz 59097 BLAKE2B 
231b238ac3b15cc2c2d9ad927f80ae72d8ae4c649277515f32df6cc04275ccd38db5307d627572af547501e6522c06c86dc279dc3e13b5385f14e24032f6fe69
 SHA512 
747c13e2c5bd45a1dc6c1426f8c7637f638ada9dd4c9aa3edf4ef8367060e73226dc4bcde6380fac25ed47ebf4097fd223c72fadc3cceba8c71dd0f0571e47eb

diff --git a/dev-lang/nim/nim-2.2.4.ebuild b/dev-lang/nim/nim-2.2.4.ebuild
new file mode 100644
index 000000000000..4b6dee2731e0
--- /dev/null
+++ b/dev-lang/nim/nim-2.2.4.ebuild
@@ -0,0 +1,194 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+ATLAS_V="0.8.0"
+
+inherit edo multiprocessing shell-completion toolchain-funcs xdg-utils
+
+DESCRIPTION="Compiled, garbage-collected systems programming language"
+HOMEPAGE="https://nim-lang.org/
+       https://github.com/nim-lang/Nim/";
+
+SRC_URI="
+       https://nim-lang.org/download/${P}.tar.xz
+       https://github.com/nim-lang/atlas/archive/refs/tags/${ATLAS_V}.tar.gz
+               -> nim-atlas-${ATLAS_V}.tar.gz
+"
+
+LICENSE="MIT"
+SLOT="0"
+KEYWORDS="~amd64 ~arm ~x86"
+
+IUSE="test-js test"
+RESTRICT="!test? ( test )"
+
+BDEPEND="
+       sys-process/parallel
+       test? (
+               dev-db/sqlite:3
+               dev-libs/boehm-gc
+               dev-libs/libffi
+               dev-libs/libpcre:3
+               dev-libs/openssl
+               media-libs/libsdl
+               media-libs/libsfml
+               test-js? (
+                       net-libs/nodejs
+               )
+       )
+"
+
+PATCHES=( "${FILESDIR}/${PN}-2.2.0-makefile.patch" )
+
+src_configure() {
+       xdg_environment_reset  # bug #667182
+
+       unset NIMBLE_DIR
+       tc-export CC CXX LD
+
+       mkdir -p "${HOME}/.parallel" || die
+       touch "${HOME}/.parallel/will-cite" || die "parallel setup failed"
+
+       cat > nim.cfg <<- EOF || die "Failed to create Nim config"
+               cc:"gcc"
+               gcc.exe:"$(tc-getCC)"
+               gcc.linkerexe:"$(tc-getCC)"
+               gcc.cpp.exe:"$(tc-getCXX)"
+               gcc.cpp.linkerexe:"$(tc-getCXX)"
+               gcc.options.speed:"${CFLAGS}"
+               gcc.options.size:"${CFLAGS}"
+               gcc.options.debug:"${CFLAGS}"
+               gcc.options.always:"${CPPFLAGS}"
+               gcc.options.linker:"${LDFLAGS}"
+               gcc.cpp.options.speed:"${CXXFLAGS}"
+               gcc.cpp.options.size:"${CXXFLAGS}"
+               gcc.cpp.options.debug:"${CXXFLAGS}"
+               gcc.cpp.options.always:"${CPPFLAGS}"
+               gcc.cpp.options.linker:"${LDFLAGS}"
+
+               $([[ "${NOCOLOR}" == true || "${NOCOLOR}" == yes ]] && echo 
'--colors:"off"')
+               -d:"release"
+               --parallelBuild:"$(makeopts_jobs)"
+
+               # some tests don't work with processing hints
+               --processing:"off"
+       EOF
+
+       cp -r "${WORKDIR}/atlas-${ATLAS_V}" "${S}/dist/atlas" || die
+
+       mkdir -p "${S}/dist/atlas/dist" || die
+       cp -r "${S}/dist/nimble/vendor/sat" "${S}/dist/atlas/dist/sat" || die
+}
+
+src_compile() {
+       emake CC="$(tc-getCC)"
+
+       local -x PATH="${S}/bin:${PATH}"
+       local -a nimflags=(
+               -d:release
+               --listCmd
+               --parallelBuild:$(makeopts_jobs)
+       )
+
+       edo ./bin/nim compile "${nimflags[@]}" koch
+       edo ./koch boot "${nimflags[@]}" -d:nimUseLinenoise --skipParentCfg:off
+       edo ./koch tools "${nimflags[@]}"
+       edo ./bin/nim compile "${nimflags[@]}" ./tools/niminst/niminst.nim
+}
+
+src_test() {
+       local -x PATH="${S}/bin:${PATH}"
+       local -a nimflags=(
+               # Leave only the safe hints enabled.
+               --hint:all:off
+               --hint:User:on
+               --hint:UserRaw:on
+       )
+       local -a testament_args=(
+               --skipFrom:"${FILESDIR}/nim-2.2.2-testament-skipfile.txt"
+               --nim:"bin/nim"
+               --targets:"$(usex test-js 'c js' 'c')"
+       )
+
+       if [[ "${NOCOLOR}" == true || "${NOCOLOR}" == yes ]] ; then
+               testament_args+=( --colors:off )
+       fi
+
+       local -a categories=()
+       readarray -t categories < \
+               <(find tests -mindepth 1 -maxdepth 1 -type d -printf "%P\n" | 
sort)
+
+       # AdditionalCategories from "testament/categories.nim".
+       categories+=( debugger examples lib )
+
+       local test_return=0
+
+       local tcat=""
+       local checkpoint=""
+       for tcat in "${categories[@]}"; do
+               # Use checkpoints for less painful testing.
+               checkpoint="${T}/.testament-${tcat}"
+
+               if [[ -f "${checkpoint}" ]] ; then
+                       continue
+               fi
+
+               case "${tcat}" in
+                       testdata )
+                               :
+                               ;;
+
+                       arc | async | coroutines | errmsgs | exception | gc | \
+                       ic | int | js | msgs | objects | overflow | \
+                       stdlib | stylecheck | system | testament | untestable | 
\
+                       valgrind )
+                               einfo "Skipped nim test category: ${tcat}"
+                               ;;
+
+                       * )
+                               einfo "Running tests in category '${tcat}'..."
+
+                               nonfatal \
+                                       edo ./bin/testament 
"${testament_args[@]}" \
+                                       category "${tcat}" "${nimflags[@]}" \
+                                       || test_return=1
+                               ;;
+               esac
+
+               touch "${checkpoint}" || die
+       done
+
+       if [[ "${test_return}" -eq 1 ]] ; then
+               die "tests failed, please inspect the failed test categories 
above"
+       fi
+}
+
+src_install() {
+       local -x PATH="${S}/bin:${PATH}"
+
+       edo ./koch install "${ED}/usr/lib"
+       dosym -r /usr/lib/nim/bin/nim /usr/bin/nim
+
+       # "./koch install" installs only "nim" binary but not the rest.
+       local exe=""
+       while read -r exe ; do
+               einfo "Installing nim support tool: ${exe}"
+
+               exeinto /usr/bin
+               doexe "${exe}"
+       done < \
+                <(find ./bin -type f -not -iname nim)
+
+       newbashcomp dist/nimble/nimble.bash-completion nimble
+       newbashcomp tools/nim.bash-completion nim
+       newzshcomp dist/nimble/nimble.zsh-completion _nimble
+       newzshcomp tools/nim.zsh-completion _nim
+
+       # Install the @nim-rebuild set for Portage.
+       insinto /usr/share/portage/config/sets
+       newins "${FILESDIR}/nim-sets.conf" nim.conf
+
+       einstalldocs
+}

Reply via email to